Acquire a builder token
Updated
Acquires a builder token for creating a Cloud Transcoding task.
https://api.sd-rtn.com/v1/projects/{appId}/rtsc/cloud-transcoder/builderTokensBefore you create a Cloud Transcoding task, call the builderTokens endpoint to retrieve a builder token.
Path Parameters
appIdstringThe App ID of your project from Agora Console.
Header Parameters
Content-TypestringThe request content type. Use application/json.
X-Request-IDstringUUID (Universally Unique Identifier), used to identify this request.
If the request fails, print out the value in the log to troubleshoot the problem. If the response status code of the request is not 2XX, then the response header may not contain this field.
Request Body
application/json
instanceIdstringThe instanceId you specified in the request.
servicesobjectcloudTranscoderobjectserviceTypestringShould be "cloudTranscoderV2".
The service type. Use "cloudTranscoderV2".
configobjectSame as the fields you set in the Create request body.
transcoderobjectidleTimeoutnumberThe maximum period, in seconds, that Cloud Transcoder can be idle. If the idle state exceeds this value, Cloud Transcoder is automatically destroyed.
streamProcessModestringIf this parameter is not specified, the working mode of Cloud transcoder is the merge mode. You can specify the following modes:
heterogeneous-single: Heterogeneous single stream mode. The types of input stream and output stream can be different or the same. The currently supported stream types are RTC and CDN.single: RTC stream relay mode. Relays the host's audio and video data and signaling in the source channel to the destination channel.
Note
-
If you set
streamProcessModetoheterogeneous-singleorsingle, then theaudioInputsorvideoInputslist may contain at most one item. -
If you need to mix audio, combine images, or mix audio and combine images, no
streamProcessModesettings are required.
audioInputsarray<object>Audio input source list, supports two types: RTC audio stream and CDN audio stream. If you specify multiple input audio sources, the streams are mixed.
Note
Either rtc or streamUrl must be filled in.
streamUrlstringThe URL of the audio source stream. Required when the audio input source is CDN.
volumenumberThe volume of the audio source stream. This parameter only takes effect when the audio input source is CDN.
repeatnumberThe number of times to play the media stream. 1 means play once, -1 means loop, and any positive integer specifies a playback count.
rtcobjectWhen the audio input source is RTC, this object is required.
rtcChannelstringThe RTC channel name for the transcoded audio and video.
The RTC channel name for the audio input source. Currently, you can only subscribe to audio and video sources from a single channel; the audio and video sources must belong to the same channel.
The RTC channel name for the video input source. Currently, you can only subscribe to audio and video sources from a single channel; the audio and video sources must belong to the same channel.
rtcUidnumberThe UID of the RTC channel for the transcoded audio and video streams. Make sure this value is different from the UID of other users in the channel.
The UID corresponding to the audio input source. The same UID must not exist in the RTC channel.
The UID corresponding to the video input source. The same UID must not exist in the RTC channel.
rtcTokenstringThe token that the Cloud Transcoder uses to join the output RTC channel. Using a token ensures channel security and prevents malicious users from disrupting other users in the channel. See Token authentication for details.
When generating this token, use outputs.rtc.rtcUid to generate the token.
The token that the Cloud Transcoder uses to join the RTC channel for transcoding. Using a token ensures channel security and prevents malicious users from disrupting other users in the channel. See Token authentication for details.
The UID of Cloud Transcoder in the RTC channel is randomly assigned by Agora. Therefore, when generating a token, set the uid to 0.
videoInputsarray<object>Video input source list, supports RTC video stream and CDN video stream. If you specify multiple input video sources, the streams are merged.
streamUrlstringThe URL of the video source stream. Required when the video input source is CDN.
repeatnumberThe number of times to play the media stream. 1 means play once, -1 means loop, and any positive integer specifies a playback count.
rtcobjectThis object is required when the video input source is RTC.
rtcChannelstringThe RTC channel name for the transcoded audio and video.
The RTC channel name for the audio input source. Currently, you can only subscribe to audio and video sources from a single channel; the audio and video sources must belong to the same channel.
The RTC channel name for the video input source. Currently, you can only subscribe to audio and video sources from a single channel; the audio and video sources must belong to the same channel.
rtcUidnumberThe UID of the RTC channel for the transcoded audio and video streams. Make sure this value is different from the UID of other users in the channel.
The UID corresponding to the audio input source. The same UID must not exist in the RTC channel.
The UID corresponding to the video input source. The same UID must not exist in the RTC channel.
rtcTokenstringThe token that the Cloud Transcoder uses to join the output RTC channel. Using a token ensures channel security and prevents malicious users from disrupting other users in the channel. See Token authentication for details.
When generating this token, use outputs.rtc.rtcUid to generate the token.
The token that the Cloud Transcoder uses to join the RTC channel for transcoding. Using a token ensures channel security and prevents malicious users from disrupting other users in the channel. See Token authentication for details.
The UID of Cloud Transcoder in the RTC channel is randomly assigned by Agora. Therefore, when generating a token, set the uid to 0.
placeholderImageUrlstringThe URL of the placeholder image displayed when the user is offline. It must be a valid image URL and contain the jpg or png suffix.
regionobjectxnumberThe x coordinate of the watermark on the canvas (px). The x coordinate is the horizontal displacement of the upper left corner of the image relative to the origin.
The x coordinate of the image on the canvas (px). The x coordinate is the horizontal displacement of the upper left corner of the image relative to the origin, where the upper left corner of the canvas is the origin.
ynumberThe y coordinate of the watermark on the canvas (px). The y coordinate is the vertical displacement of the upper left corner of the image relative to the origin.
The y coordinate of the image on the canvas (px). The y coordinate is the vertical displacement of the upper left corner of the image relative to the origin, where the upper left corner of the canvas is the origin.
widthnumberThe width of the watermark (px).
The width of the screen (px).
heightnumberThe height of the watermark (px).
The height of the screen (px).
zOrdernumberThe layer order of the watermark. 0 represents the bottom layer. 100 represents the top layer.
The layer order of the host screen. 2 represents the layer above the placeholder layer. 100 represents the top layer.
canvasobjectwidthnumberThe width of the canvas (px).
heightnumberThe height of the canvas (px).
colornumberThe background color of the canvas as a decimal RGB value.
backgroundImagestringCanvas background image. Must be a valid image URL with a jpg or png suffix. If omitted, there is no canvas background image.
fillModestringFill mode for the canvas background image.
watermarksarray<object>Watermark list.
imageUrlstringThe URL of the watermark image.
regionobjectxnumberThe x coordinate of the watermark on the canvas (px). The x coordinate is the horizontal displacement of the upper left corner of the image relative to the origin.
The x coordinate of the image on the canvas (px). The x coordinate is the horizontal displacement of the upper left corner of the image relative to the origin, where the upper left corner of the canvas is the origin.
ynumberThe y coordinate of the watermark on the canvas (px). The y coordinate is the vertical displacement of the upper left corner of the image relative to the origin.
The y coordinate of the image on the canvas (px). The y coordinate is the vertical displacement of the upper left corner of the image relative to the origin, where the upper left corner of the canvas is the origin.
widthnumberThe width of the watermark (px).
The width of the screen (px).
heightnumberThe height of the watermark (px).
The height of the screen (px).
zOrdernumberThe layer order of the watermark. 0 represents the bottom layer. 100 represents the top layer.
The layer order of the host screen. 2 represents the layer above the placeholder layer. 100 represents the top layer.
The layer order of the watermark.
fillModestringWatermark fill mode:
"FILL": Scale the image and crop it in the center while maintaining the aspect ratio."FIT": Scale the image to fill the display while maintaining the aspect ratio.
outputsarray<object>Configure output settings to publish to an RTC channel or CDN address.
You must specify either streamUrl or rtc.
Configure output settings to publish to a single RTC channel or CDN address.
You must specify either streamUrl or rtc.
streamUrlstringCDN streaming address.
rtcobjectRequired for publishing to an RTC channel. Currently, you can publish to only one RTC channel.
rtcChannelstringThe RTC channel name for the transcoded audio and video.
The RTC channel name for the audio input source. Currently, you can only subscribe to audio and video sources from a single channel; the audio and video sources must belong to the same channel.
The RTC channel name for the video input source. Currently, you can only subscribe to audio and video sources from a single channel; the audio and video sources must belong to the same channel.
rtcUidnumberThe UID of the RTC channel for the transcoded audio and video streams. Make sure this value is different from the UID of other users in the channel.
The UID corresponding to the audio input source. The same UID must not exist in the RTC channel.
The UID corresponding to the video input source. The same UID must not exist in the RTC channel.
rtcTokenstringThe token that the Cloud Transcoder uses to join the output RTC channel. Using a token ensures channel security and prevents malicious users from disrupting other users in the channel. See Token authentication for details.
When generating this token, use outputs.rtc.rtcUid to generate the token.
The token that the Cloud Transcoder uses to join the RTC channel for transcoding. Using a token ensures channel security and prevents malicious users from disrupting other users in the channel. See Token authentication for details.
The UID of Cloud Transcoder in the RTC channel is randomly assigned by Agora. Therefore, when generating a token, set the uid to 0.
audioOptionobjectprofileTypestringAudio properties of the transcoded output:
"AUDIO_PROFILE_DEFAULT": 48 kHz sampling rate, music encoding, mono channel, maximum encoding bitrate is 64 Kbps."AUDIO_PROFILE_SPEECH_STANDARD": 32 kHz sampling rate, speech encoding, mono channel, maximum encoding bitrate is 18 Kbps."AUDIO_PROFILE_MUSIC_STANDARD": 48 KHz sampling rate, music encoding, mono channel, maximum encoding bitrate is 64 Kbps."AUDIO_PROFILE_MUSIC_STANDARD_STEREO": 48 KHz sampling rate, music encoding, stereo channel, maximum encoding bitrate is 80 Kbps."AUDIO_PROFILE_MUSIC_HIGH_QUALITY": 48 KHz sampling rate, music encoding, mono channel, maximum encoding bitrate is 96 Kbps."AUDIO_PROFILE_MUSIC_HIGH_QUALITY_STEREO": 48 kHz sampling rate, music encoding, dual channels, and a maximum encoding bitrate of 128 Kbps.
videoOptionobjectwidthnumberThe width of the transcoded output video (px).
heightnumberThe height of the transcoded output video (px).
bitratenumberThe bitrate of the transcoded output video.
codecstringThe codec used to transcode the output video.
Possible values:
"H264": Standard H.264 encoding."VP8": Standard VP8 encoding.
fpsnumberThe frame rate (fps) of the transcoded output video.
modestringCan be set to RAW, which means the output video is not transcoded. The encoding format of the input video remains unchanged.
If the output video is transcoded, do not set this field.
In RAW mode, the number of inputs set in videoInputs can only be 1.
lowBitrateHighQualitybooleanWhether to enable low-bitrate high-quality mode.
Response
-
If the returned status code is
200, the request was successful. The response body contains the result of the request. -
If the returned status code is not
200, the request failed.
Response Body
The request succeeded and returned a builder token.
Response Headers
createTsnumberUnix timestamp (seconds) when the builderToken was generated
instanceIdstringThe user-specified instance ID.
tokenNamestringThe value of the builderToken. Use this value when calling other methods for this instance.
Reference
Note the following guidelines when using a builderToken:
- After calling this endpoint successfully, you receive a
builderTokenin the response body. You can use abuilderTokenfor a single Cloud Transcoding task. - The validity period of a
builderTokenfor creating Cloud Transcoding is 5 minutes. To ensure successful Cloud Transcoding, best practice is to initiate the correspondingCreaterequest within 2 seconds after eachAcquireresponse is received. - Making batch
Createrequests after batchbuilderTokenrequests may cause the request to fail.
Output destination constraints
- A single transcoding task cannot push to both a CDN address and an RTC channel simultaneously. To push to both destinations, create two separate tasks.
- If the audio or video configurations differ between the two destinations, create two separate tasks.
- To push to multiple CDN addresses, include all destination addresses within a single
outputsobject. - Each transcoding task can push to only one RTC channel. To push to two different RTC channels, create two separate tasks.
Request examples
curl --request post \ --url https://api.sd-rtn.com/v1/projects/:appId/rtsc/cloud-transcoder/builderTokens \ --header 'Authorization: Basic <credentials>' \ --header 'Content-Type: <string>' \ --data ' { "instanceId": "abc13328", "services": { "cloudTranscoder": { "serviceType": "cloudTranscoderV2", "config": { "transcoder": { "idleTimeout": 300, "audioInputs": [ { "rtc": { "rtcChannel": "test01", "rtcUid": 123, "rtcToken": "<your_rtc_token>" } }, { "rtc": { "rtcChannel": "test01", "rtcUid": 456, "rtcToken": "<your_rtc_token>" } } ], "canvas": { "width": 960, "height": 480, "color": 0, "backgroundImage": "https://web-cdn.agora.io/website-files/images/new-home-2-banne-online-karaoke-bg.jpg", "fillMode": "FIT" }, "waterMarks": [ { "imageUrl": "https://web-cdn.agora.io/website-files/images/advantage-interactive-live-streaming.png", "region": { "x": 0, "y": 0, "width": 100, "height": 100, "zOrder": 50 } } ], "videoInputs": [ { "rtc": { "rtcChannel": "test01", "rtcUid": 123, "rtcToken": "<your_rtc_token>" }, "placeholderImageUrl": "https://web-cdn.agora.io/website-files/images/new-home-2-banner-realtime-bg.jpg", "region": { "x": 0, "y": 0, "width": 320, "height": 360, "zOrder": 2 } }, { "rtc": { "rtcChannel": "test01", "rtcUid": 456, "rtcToken": "<your_rtc_token>" }, "region": { "x": 320, "y": 0, "width": 320, "height": 320, "zOrder": 2 } } ], "outputs": [ { "rtc": { "rtcChannel": "test02", "rtcUid": 1000, "rtcToken": "<your_rtc_token>" }, "audioOption": { "profileType": "AUDIO_PROFILE_MUSIC_STANDARD" }, "videoOption": { "fps": 30, "codec": "H264", "bitrate": 800, "width": 960, "height": 48 } } ] } } } } }'Response example
{ "createTs": 1661324606, "instanceId": "abc13328", "tokenName": "xUwUbQf9ZxxxxxtLslGnDg0lk8RYaUE0***"}